<?php


namespace Drp\SimpleCms\Contracts;

interface IsManaged
{
    public function getCallbackForUpdateRequest(): ?\Closure;

    // phpcs:disable SlevomatCodingStandard.TypeHints.TypeHintDeclaration.UselessDocComment

    /**
     * @SuppressWarnings(PHPMD.BooleanArgumentFlag)
     */
    public static function contentLabel(?bool $plural = false, ?bool $lowerCase = false): string;

    // phpcs:enable SlevomatCodingStandard.TypeHints.TypeHintDeclaration.UselessDocComment

    public static function contentKey(): string;

    public static function relationshipName(): string;

    public function getContentRouteParameters(): array;

    public function getVersionRouteParameters(): array;

    public function adminEditUrl(): string;

    /**
     * @return mixed
     */
    public function frontEndUrl();

    public function destroyAllVersion(): int;
}
